Index: /palm/trunk/SOURCE/data_output_2d.f90
===================================================================
--- /palm/trunk/SOURCE/data_output_2d.f90	(revision 2231)
+++ /palm/trunk/SOURCE/data_output_2d.f90	(revision 2232)
@@ -20,4 +20,5 @@
 ! Current revisions:
 ! -----------------
+! Adjustments to new surface concept
 ! 
 !
@@ -162,7 +163,7 @@
 
     USE arrays_3d,                                                             &
-        ONLY:  dzw, e, nr, ol, p, pt, precipitation_amount, precipitation_rate,&
-               prr,q, qc, ql, ql_c, ql_v, ql_vp, qr, qsws, rho_ocean, s, sa, shf,    &
-               ssws, tend, ts, u, us, v, vpt, w, z0, z0h, z0q, zu, zw
+        ONLY:  dzw, e, nr, p, pt, precipitation_amount, precipitation_rate,    &
+               prr, q, qc, ql, ql_c, ql_v, ql_vp, qr, rho_ocean, s, sa,        &
+               tend, u, v, vpt, w, zu, zw
         
     USE averaging
@@ -177,5 +178,5 @@
                do2d_xz_last_time, do2d_xz_n, do2d_xz_time_count,               &
                do2d_yz_last_time, do2d_yz_n, do2d_yz_time_count,               &
-               ibc_uv_b, io_blocks, io_group, message_string,                  &
+               ibc_uv_b, io_blocks, io_group, land_surface, message_string,    &
                ntdim_2d_xy, ntdim_2d_xz, ntdim_2d_yz,                          &
                psolver, section, simulated_time, simulated_time_chr,           &
@@ -195,5 +196,5 @@
     
     USE land_surface_model_mod,                                                &
-        ONLY:  land_surface, lsm_data_output_2d, zs
+        ONLY:  lsm_data_output_2d, zs
     
 #if defined( __netcdf )
@@ -214,4 +215,7 @@
     USE radiation_model_mod,                                                   &
         ONLY:  radiation, radiation_data_output_2d
+
+    USE surface_mod,                                                           &
+        ONLY:  surf_def_h, surf_lsm_h, surf_usm_h
 
     IMPLICIT NONE
@@ -234,4 +238,5 @@
     INTEGER(iwp) ::  l         !< 
     INTEGER(iwp) ::  layer_xy  !< 
+    INTEGER(iwp) ::  m         !<
     INTEGER(iwp) ::  n         !< 
     INTEGER(iwp) ::  nis       !<
@@ -255,4 +260,6 @@
     REAL(wp), DIMENSION(:,:), ALLOCATABLE   ::  local_2d            !<
     REAL(wp), DIMENSION(:,:), ALLOCATABLE   ::  local_2d_l          !<
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE   ::  tmp_2d              !< temporary field used to exchange surface-related quantities
+
     REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  local_pf            !<
     REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  local_2d_sections   !<
@@ -417,4 +424,9 @@
 !-- Allocate a temporary array for resorting (kji -> ijk).
     ALLOCATE( local_pf(nxlg:nxrg,nysg:nyng,nzb:nzt+1) )
+    local_pf = 0.0
+!
+!-- Allocate temporary array used for exchanging ghoist points of surface-data
+    ALLOCATE( tmp_2d(nysg:nyng,nxlg:nxrg) )
+    tmp_2d = 0.0
 
 !
@@ -485,9 +497,28 @@
              CASE ( 'ol*_xy' )        ! 2d-array
                 IF ( av == 0 ) THEN
-                   DO  i = nxlg, nxrg
-                      DO  j = nysg, nyng
-                         local_pf(i,j,nzb+1) = ol(j,i)
-                      ENDDO
-                   ENDDO
+                   DO  m = 1, surf_def_h(0)%ns
+                      i = surf_def_h(0)%i(m)
+                      j = surf_def_h(0)%j(m)
+                      tmp_2d(j,i) = surf_def_h(0)%ol(m)
+                   ENDDO
+                   DO  m = 1, surf_lsm_h%ns
+                      i = surf_lsm_h%i(m)
+                      j = surf_lsm_h%j(m)
+                      tmp_2d(j,i) = surf_lsm_h%ol(m)
+                   ENDDO
+                   DO  m = 1, surf_usm_h%ns
+                      i = surf_usm_h%i(m)
+                      j = surf_usm_h%j(m)
+                      tmp_2d(j,i) = surf_usm_h%ol(m)
+                   ENDDO
+
+                   CALL exchange_horiz_2d( tmp_2d, nbgp )
+
+                   DO  i = nxlg, nxrg
+                      DO  j = nysg, nyng
+                         local_pf(i,j,nzb+1) = tmp_2d(j,i)
+                      ENDDO
+                   ENDDO
+
                 ELSE
                    DO  i = nxlg, nxrg
@@ -740,7 +771,25 @@
              CASE ( 'qsws*_xy' )        ! 2d-array
                 IF ( av == 0 ) THEN
-                   DO  i = nxlg, nxrg
-                      DO  j = nysg, nyng
-                         local_pf(i,j,nzb+1) =  qsws(j,i)
+                   DO  m = 1, surf_def_h(0)%ns
+                      i = surf_def_h(0)%i(m)
+                      j = surf_def_h(0)%j(m)
+                      tmp_2d(j,i) = surf_def_h(0)%qsws(m)
+                   ENDDO
+                   DO  m = 1, surf_lsm_h%ns
+                      i = surf_lsm_h%i(m)
+                      j = surf_lsm_h%j(m)
+                      tmp_2d(j,i) = surf_lsm_h%qsws(m)
+                   ENDDO
+                   DO  m = 1, surf_usm_h%ns
+                      i = surf_usm_h%i(m)
+                      j = surf_usm_h%j(m)
+                      tmp_2d(j,i) = surf_usm_h%qsws(m)
+                   ENDDO
+
+                   CALL exchange_horiz_2d( tmp_2d, nbgp )
+
+                   DO  i = nxlg, nxrg
+                      DO  j = nysg, nyng
+                         local_pf(i,j,nzb+1) = tmp_2d(j,i)
                       ENDDO
                    ENDDO
@@ -796,7 +845,25 @@
              CASE ( 'shf*_xy' )        ! 2d-array
                 IF ( av == 0 ) THEN
-                   DO  i = nxlg, nxrg
-                      DO  j = nysg, nyng
-                         local_pf(i,j,nzb+1) =  shf(j,i)
+                   DO  m = 1, surf_def_h(0)%ns
+                      i = surf_def_h(0)%i(m)
+                      j = surf_def_h(0)%j(m)
+                      tmp_2d(j,i) = surf_def_h(0)%shf(m)
+                   ENDDO
+                   DO  m = 1, surf_lsm_h%ns
+                      i = surf_lsm_h%i(m)
+                      j = surf_lsm_h%j(m)
+                      tmp_2d(j,i) = surf_lsm_h%shf(m)
+                   ENDDO
+                   DO  m = 1, surf_usm_h%ns
+                      i = surf_usm_h%i(m)
+                      j = surf_usm_h%j(m)
+                      tmp_2d(j,i) = surf_usm_h%shf(m)
+                   ENDDO
+
+                   CALL exchange_horiz_2d( tmp_2d, nbgp )
+
+                   DO  i = nxlg, nxrg
+                      DO  j = nysg, nyng
+                         local_pf(i,j,nzb+1) = tmp_2d(j,i)
                       ENDDO
                    ENDDO
@@ -814,7 +881,25 @@
              CASE ( 'ssws*_xy' )        ! 2d-array
                 IF ( av == 0 ) THEN
-                   DO  i = nxlg, nxrg
-                      DO  j = nysg, nyng
-                         local_pf(i,j,nzb+1) =  ssws(j,i)
+                   DO  m = 1, surf_def_h(0)%ns
+                      i = surf_def_h(0)%i(m)
+                      j = surf_def_h(0)%j(m)
+                      tmp_2d(j,i) = surf_def_h(0)%ssws(m)
+                   ENDDO
+                   DO  m = 1, surf_lsm_h%ns
+                      i = surf_lsm_h%i(m)
+                      j = surf_lsm_h%j(m)
+                      tmp_2d(j,i) = surf_lsm_h%ssws(m)
+                   ENDDO
+                   DO  m = 1, surf_usm_h%ns
+                      i = surf_usm_h%i(m)
+                      j = surf_usm_h%j(m)
+                      tmp_2d(j,i) = surf_usm_h%ssws(m)
+                   ENDDO
+
+                   CALL exchange_horiz_2d( tmp_2d, nbgp )
+
+                   DO  i = nxlg, nxrg
+                      DO  j = nysg, nyng
+                         local_pf(i,j,nzb+1) = tmp_2d(j,i)
                       ENDDO
                    ENDDO
@@ -832,9 +917,28 @@
              CASE ( 't*_xy' )        ! 2d-array
                 IF ( av == 0 )  THEN
-                   DO  i = nxlg, nxrg
-                      DO  j = nysg, nyng
-                         local_pf(i,j,nzb+1) = ts(j,i)
-                      ENDDO
-                   ENDDO
+                   DO  m = 1, surf_def_h(0)%ns
+                      i = surf_def_h(0)%i(m)
+                      j = surf_def_h(0)%j(m)
+                      tmp_2d(j,i) = surf_def_h(0)%ts(m)
+                   ENDDO
+                   DO  m = 1, surf_lsm_h%ns
+                      i = surf_lsm_h%i(m)
+                      j = surf_lsm_h%j(m)
+                      tmp_2d(j,i) = surf_lsm_h%ts(m)
+                   ENDDO
+                   DO  m = 1, surf_usm_h%ns
+                      i = surf_usm_h%i(m)
+                      j = surf_usm_h%j(m)
+                      tmp_2d(j,i) = surf_usm_h%ts(m)
+                   ENDDO
+
+                   CALL exchange_horiz_2d( tmp_2d, nbgp )
+
+                   DO  i = nxlg, nxrg
+                      DO  j = nysg, nyng
+                         local_pf(i,j,nzb+1) = tmp_2d(j,i)
+                      ENDDO
+                   ENDDO
+
                 ELSE
                    DO  i = nxlg, nxrg
@@ -864,7 +968,25 @@
              CASE ( 'u*_xy' )        ! 2d-array
                 IF ( av == 0 )  THEN
-                   DO  i = nxlg, nxrg
-                      DO  j = nysg, nyng
-                         local_pf(i,j,nzb+1) = us(j,i)
+                   DO  m = 1, surf_def_h(0)%ns
+                      i = surf_def_h(0)%i(m)
+                      j = surf_def_h(0)%j(m)
+                      tmp_2d(j,i) = surf_def_h(0)%us(m)
+                   ENDDO
+                   DO  m = 1, surf_lsm_h%ns
+                      i = surf_lsm_h%i(m)
+                      j = surf_lsm_h%j(m)
+                      tmp_2d(j,i) = surf_lsm_h%us(m)
+                   ENDDO
+                   DO  m = 1, surf_usm_h%ns
+                      i = surf_usm_h%i(m)
+                      j = surf_usm_h%j(m)
+                      tmp_2d(j,i) = surf_usm_h%us(m)
+                   ENDDO
+
+                   CALL exchange_horiz_2d( tmp_2d, nbgp )
+
+                   DO  i = nxlg, nxrg
+                      DO  j = nysg, nyng
+                         local_pf(i,j,nzb+1) = tmp_2d(j,i)
                       ENDDO
                    ENDDO
@@ -912,9 +1034,28 @@
              CASE ( 'z0*_xy' )        ! 2d-array
                 IF ( av == 0 ) THEN
-                   DO  i = nxlg, nxrg
-                      DO  j = nysg, nyng
-                         local_pf(i,j,nzb+1) =  z0(j,i)
-                      ENDDO
-                   ENDDO
+                   DO  m = 1, surf_def_h(0)%ns
+                      i = surf_def_h(0)%i(m)
+                      j = surf_def_h(0)%j(m)
+                      tmp_2d(j,i) = surf_def_h(0)%z0(m)
+                   ENDDO
+                   DO  m = 1, surf_lsm_h%ns
+                      i = surf_lsm_h%i(m)
+                      j = surf_lsm_h%j(m)
+                      tmp_2d(j,i) = surf_lsm_h%z0(m)
+                   ENDDO
+                   DO  m = 1, surf_usm_h%ns
+                      i = surf_usm_h%i(m)
+                      j = surf_usm_h%j(m)
+                      tmp_2d(j,i) = surf_usm_h%z0(m)
+                   ENDDO
+
+                   CALL exchange_horiz_2d( tmp_2d, nbgp )
+
+                   DO  i = nxlg, nxrg
+                      DO  j = nysg, nyng
+                         local_pf(i,j,nzb+1) = tmp_2d(j,i)
+                      ENDDO
+                   ENDDO
+
                 ELSE
                    DO  i = nxlg, nxrg
@@ -930,7 +1071,25 @@
              CASE ( 'z0h*_xy' )        ! 2d-array
                 IF ( av == 0 ) THEN
-                   DO  i = nxlg, nxrg
-                      DO  j = nysg, nyng
-                         local_pf(i,j,nzb+1) =  z0h(j,i)
+                   DO  m = 1, surf_def_h(0)%ns
+                      i = surf_def_h(0)%i(m)
+                      j = surf_def_h(0)%j(m)
+                      tmp_2d(j,i) = surf_def_h(0)%z0h(m)
+                   ENDDO
+                   DO  m = 1, surf_lsm_h%ns
+                      i = surf_lsm_h%i(m)
+                      j = surf_lsm_h%j(m)
+                      tmp_2d(j,i) = surf_lsm_h%z0h(m)
+                   ENDDO
+                   DO  m = 1, surf_usm_h%ns
+                      i = surf_usm_h%i(m)
+                      j = surf_usm_h%j(m)
+                      tmp_2d(j,i) = surf_usm_h%z0h(m)
+                   ENDDO
+
+                   CALL exchange_horiz_2d( tmp_2d, nbgp )
+
+                   DO  i = nxlg, nxrg
+                      DO  j = nysg, nyng
+                         local_pf(i,j,nzb+1) = tmp_2d(j,i)
                       ENDDO
                    ENDDO
@@ -948,7 +1107,25 @@
              CASE ( 'z0q*_xy' )        ! 2d-array
                 IF ( av == 0 ) THEN
-                   DO  i = nxlg, nxrg
-                      DO  j = nysg, nyng
-                         local_pf(i,j,nzb+1) =  z0q(j,i)
+                   DO  m = 1, surf_def_h(0)%ns
+                      i = surf_def_h(0)%i(m)
+                      j = surf_def_h(0)%j(m)
+                      tmp_2d(j,i) = surf_def_h(0)%z0q(m)
+                   ENDDO
+                   DO  m = 1, surf_lsm_h%ns
+                      i = surf_lsm_h%i(m)
+                      j = surf_lsm_h%j(m)
+                      tmp_2d(j,i) = surf_lsm_h%z0q(m)
+                   ENDDO
+                   DO  m = 1, surf_usm_h%ns
+                      i = surf_usm_h%i(m)
+                      j = surf_usm_h%j(m)
+                      tmp_2d(j,i) = surf_usm_h%z0q(m)
+                   ENDDO
+
+                   CALL exchange_horiz_2d( tmp_2d, nbgp )
+
+                   DO  i = nxlg, nxrg
+                      DO  j = nysg, nyng
+                         local_pf(i,j,nzb+1) = tmp_2d(j,i)
                       ENDDO
                    ENDDO
Index: /palm/trunk/SOURCE/data_output_3d.f90
===================================================================
--- /palm/trunk/SOURCE/data_output_3d.f90	(revision 2231)
+++ /palm/trunk/SOURCE/data_output_3d.f90	(revision 2232)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! Adjustments to new topography concept
 ! 
 ! Former revisions:
@@ -152,6 +152,6 @@
 
     USE arrays_3d,                                                             &
-        ONLY:  e, nr, p, pt, prr, q, qc, ql, ql_c, ql_v, qr, rho_ocean, s, sa, tend, &
-               u, v, vpt, w
+        ONLY:  e, nr, p, pt, prr, q, qc, ql, ql_c, ql_v, qr, rho_ocean, s, sa, &
+               tend, u, v, vpt, w
         
     USE averaging
@@ -162,7 +162,7 @@
     USE control_parameters,                                                    &
         ONLY:  cloud_physics, do3d, do3d_no, do3d_time_count, io_blocks,       &
-               io_group, message_string, ntdim_3d, nz_do3d, psolver,           &
-               simulated_time, time_since_reference_point, urban_surface,      &
-               varnamelength
+               io_group, land_surface, message_string, ntdim_3d, nz_do3d,      &
+               psolver, simulated_time, time_since_reference_point,            &
+               urban_surface, varnamelength
         
     USE cpulog,                                                                &
@@ -175,5 +175,5 @@
     
     USE land_surface_model_mod,                                                &
-        ONLY: land_surface, lsm_data_output_3d, nzb_soil, nzt_soil
+        ONLY: lsm_data_output_3d, nzb_soil, nzt_soil
 
 #if defined( __netcdf )
